<?php
defined('ABSPATH') or die('Plugin file cannot be accessed directly.');
?>
<script>
// API helper object
var gosh_util = {
    request: function(token, url, type, data, callback){
        $.ajax({
            url: url,
            type: type,
            data: data,
            dataType: 'json',
            beforeSend : function( xhr ){
               xhr.setRequestHeader('Authorization', token);
            },
            success: function( response, textStatus, request ){
                if(callback) callback(response);
            },
            error: function( response ){
                if(callback) callback(response);
            },
        });
    },
    checkIfFileExist: function(url, callback){
        var http = new XMLHttpRequest();
        try{http.open('HEAD', url, true);
            http.send();
            http.onreadystatechange = function() {if (http.readyState == 4) {
                callback(http.status);
            }
            };
        }catch(err) {callback(false);}
    },
    popup: {
        open: function(url, title, w, h){
            var left = (screen.width  / 2) - (w / 2);
            var top  = (screen.height / 2) - (h / 2);
            return window.open(url, title, 'toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizable=yes, copyhistory=no, width='+w+', height='+h+', top='+top+', left='+left);
        },
        close: function(win){
            if (win) win.close();
            win = null;
        }
    },
    // Compatible with gosh.gallery
    configurationFieldControl:{
        apply: function(field){//safe to copy to other projects
            var dep = $(field).attr('data-dependent');
            if(typeof dep != 'undefined'){
                var depArr = dep.split('&');
                var check = true;
                for(i = 0; i < depArr.length; i++){
                    // ! NOT
                    var temp = depArr[i].split('!=');
                    if(temp.length < 2){
                        temp = depArr[i].split('=');
                        var negation    = false;
                    }else var negation  = true;

                    var param = temp[0];
                    var valueArr = temp[1].split('||'); // || OR
                    var errCnt = 0;
                    for(var j = 0; j < valueArr.length; j++){
                        var value = valueArr[j];
                        if($('#gosh_' + param).is('select')){
                            if(negation == false && $('#gosh_' + param).val() != value || negation == true && $('#gosh_' + param).val() == value) {
                                errCnt++;
                                check = false;
                            }
                        }else if($('#gosh_' + param).is(':checkbox')){
                            var chk = $('#gosh_' + param).is(':checked') ? "true" : "false";
                            if(negation == false && chk != value || negation == true && chk == value) {errCnt++; check = false;}
                        }

                    }
                    if(valueArr.length == 2 && errCnt < 2) check = true;
                }
                if(check === false) $('#' + field.id + '_box').hide(); else $('#' + field.id + '_box').show();
            }
            // Check for exceptions
            switch($(field).attr('id')){
                case 'gosh_rows':
                    // Responsive cols
                    if($('#gosh_layout').val() === 'grid'){
                        if($('#gosh_cols').val() == 'responsive'){
                            $('#gosh_rows').val('responsive').attr('disabled', true);
                            $('select[name=gosh_rows] option:eq(0)').attr('disabled', false).show();
                        }else {
                            if($('#gosh_rows').val() == 'responsive'){$('#gosh_rows').val('1');}
                            $('select[name=gosh_rows] option:eq(0)').attr('disabled', true).hide();
                            $('#gosh_rows').attr('disabled', false);
                        }
                        // Rows no-limit option
                        if($('#gosh_autoplay').val() === 'true') {
                            if($('#gosh_rows').val() === 'false'){$('#gosh_rows').val('1');}
                            $('select[name=gosh_rows] option:eq(1)').attr('disabled', true).hide();
                        }else if($('#gosh_layout').val() === 'grid'){
                            $('select[name=gosh_rows] option:eq(1)').attr('disabled', false).show();
                        }
                    }
                break;
                case 'gosh_transitionSpeed':
                    // Hide transitionSpeed
                    if($('#gosh_autoplay').val() == 'false' && $('#gosh_layout').val() == 'grid'){
                        $('#gosh_transitionSpeed_box').hide();
                    }else{
                        if($('#gosh_advancedSettings').is(':visible') && $('#gosh_advancedSettings').val() == 'true') {$('#gosh_transitionSpeed_box').show();}
                    }
                break;
            }
        },
        check:function(){
            $('.gosh-settings-input-field').each(function(index, field){
               gosh_util.configurationFieldControl.apply(field);
            });
        }
    }
};

var GOSH_WGT = {
  info: function(callback){
      console.log('Getting info');
      gosh_util.request(GOSH_CFG.get('user_token'),
                        GOSH_CFG.get('apiOrigin') + '/wordpress/gallery?user_id=' + GOSH_CFG.get('user_id') + '&project_id=' + GOSH_CFG.get('site_id') + '|-|' + GOSH_CFG.get('element_id') + '&setting=1',
                        'GET',
                        '',
                        function(result){
                            console.log('Result:', result);
                            callback(result);
                        });
  },
  create: function(callback){
      gosh_util.request(GOSH_CFG.get('user_token'),
                   GOSH_CFG.get('apiOrigin') + '/wordpress/gallery/create',
                   'POST',
                   {key_word:'', site_id:GOSH_CFG.get('site_id'), user_id:GOSH_CFG.get('user_id'), element_id:GOSH_CFG.get('element_id')},
                   function(result){
                       //console.log('GOSH_WGT.create:', result);
                       callback(result);}
                   );
  },
  update: function(callback){
      var options = GOSH_WGT.getOptions();
      options.platform = 'wordpress';
      console.log('updating next:', JSON.stringify(options));
      // Validate #hashtag || @username
      options.key_word = /^(#|@){1}[^\ #@]* *$/.test(options.key_word) ?  options.key_word : ' ';
      gosh_util.request(GOSH_CFG.get('user_token'),
                   GOSH_CFG.get('apiOrigin') + '/wordpress/gallery/update',
                   'POST',
                   {key_word:options.key_word, settings: JSON.stringify(options), site_id:GOSH_CFG.get('site_id'), user_id:GOSH_CFG.get('user_id'), element_id:GOSH_CFG.get('element_id'), setting:1},
                   function(result){if(callback) callback(result, options);}
      );
  },
  remove: function(media_id){
      gosh_util.request(GOSH_CFG.get('user_token'),
                   GOSH_CFG.get('apiOrigin') + '/wordpress/gallery/remove_media',
                   'POST',
                   {site_id:GOSH_CFG.get('site_id'), user_id:GOSH_CFG.get('user_id'), element_id:GOSH_CFG.get('element_id'), media_id:media_id}
                   );
  },
  load: function(id, data, type, options){
      var options = options || {};
      var galleryType     = type || 'default';
      options.galleryType = galleryType;
      // Initialize gallery
      var w = new GSW(id, data, options);
      return w;

  },
  getData: function(hash_url, callback){
      // placeholder
      if(hash_url.indexOf('placeholder') != -1){
          $.get(GOSH_CFG.get('apiViewerRoot') + 'datas/galleries/__placeholder__.json', function(data){
               callback(data, 'special', 'placeholder');
          });
      }
      else{
          var file_url = GOSH_CFG.get('apiViewerRoot') + 'datas/galleries/' +  hash_url + '_wordpress_' + GOSH_CFG.get('user_id') + '.json';
          gosh_util.checkIfFileExist(file_url, function(result){
              // Personalized
              if(result == 200){$.get(file_url, function(data){callback(data, 'default', 'finished');});}
              // Common
              else if(result == 404){
                  gosh_util.checkIfFileExist(GOSH_CFG.get('apiViewerRoot') + 'datas/galleries/' +  hash_url + '.json', function(result){
                      // Getting data for common gallery
                      if(result == 200) {
                          $.get(GOSH_CFG.get('apiViewerRoot') + 'datas/galleries/' +  hash_url + '.json', function(data){
                              callback(data, 'default', 'finished');
                          });
                      } // generation in progress
                      else $.get(GOSH_CFG.get('apiViewerRoot') + 'datas/galleries/__wait__.json', function(data){callback(data, 'special', 'waiting');});
                  });
              }
          });
      }
  },
  getOptions: function(){
     var opt = {};
     $($('.gosh-settings-input-field').get().reverse()).each(function(index, field){
         var id  = field.id.split('gosh_')[1];
         var val = $('#' + field.id).val();
         if(typeof id !== 'undefined' && val !== ''){
             if(val === 'true' || val === 'false') opt[id] = val === 'true' ? true : false; // Bool
             else if(!isNaN(val)) opt[id] = parseInt(val); // Integer
             else opt[id] = val; // String
         }
     });
     return opt;
  },
  setOptionFields: function(key_word, opt, callback){
      for(var key in opt) if (opt.hasOwnProperty(key) && key != '') {
          if(opt[key] === true || opt[key] === false) var value = opt[key] === true ? 'true' : 'false';
          else var value = opt[key];
          $('#gosh_' + key).val(String(value));
      }
      gosh_util.configurationFieldControl.check();
      $('#gosh_key_word').val(key_word);
      $('#gosh-widget-settings-wrapper').show();
      if(callback) callback();
  },
  confirmationDialog: function(target, callback){
     var dialog = document.createElement('div');
     dialog.className = window.__goshwgt.getOption().prefix + 'confirmation-dialog';
     dialog.innerHTML = '<div class="dialog-text">Remove item from the gallery.</div><div><strong>Are you sure?<strong><br/></div>';
     var apply  = document.createElement('button');
     apply.className = 'checkmark';
     var cancel  = document.createElement('button');
     cancel.className = 'remove';
     dialog.appendChild(apply);
     dialog.appendChild(cancel);
     $(dialog).on('click', function(e){e.stopPropagation();});
     $(apply).on('click',  function(e){e.stopPropagation(); e.preventDefault(); dialog.parentNode.removeChild(dialog); callback(true);});
     $(cancel).on('click', function(e){e.stopPropagation(); dialog.parentNode.removeChild(dialog); callback(false)});
     target.insertBefore(dialog, target.firstChild);
  }
};
</script>