<?php
defined('ABSPATH') or die('Plugin file cannot be accessed directly.');

class Gosh {
	/* Settings
	 */
	function saveSettings($post_id, $data){
		return update_post_meta($post_id, GOSH_SETTINGS_VAR, $data);
	}
	function getSettings($post_id){
		$default = array("key_word"   => null,
						 "status"     => "",
						 "element_id" => $post_id,
						 "hash_url"   => "__placeholder__"
						);
		$data = get_post_meta($post_id, GOSH_SETTINGS_VAR, true);
		$settings = $data ? $data : $default;
		$settings['post_id'] = $post_id;
		return $settings;
	}
	function validateSettings($data){
		// Validate keyword
		$key_word  = sanitize_text_field($data['key_word']); // Sanitized
		if($key_word) {
			$pattern = '/^(#|@){1}[^\ #@]* *$/';
			preg_match($pattern, $key_word, $matches, PREG_OFFSET_CAPTURE); // Validated
			$result = $key_word === "" || ($key_word == strlen($key_word) > 1 && count($matches) > 0) || false;
		} else $result = true; // Allow empty string
		return $result;
	}

	/* Template
	 */
	function renderTemplate($template, array $data = array()){
        require GOSH_PLUGIN_ROOT . '/template/'.$template.'.php';
        if(isset($gosh_template)) return $gosh_template; else return false;
	}

	/* Messages
	 */
	function addMessage($post_id, $message,$type){
		$messageArr = get_post_meta($post_id, GOSH_MESSAGES_VAR);
		$messageArr[] = $message."|".$type;
		update_post_meta($post_id, GOSH_MESSAGES_VAR, $messageArr);
	}

	function printMessages($post_id){
		$messageArr = get_post_meta($post_id, GOSH_MESSAGES_VAR);
		if(!$messageArr) return;
		foreach($messageArr[0] as $item){
			if(!is_array($item)){
				list($message, $type) = explode("|", $item);
				if($message) echo "<div class='updated {$type}'><p>{$message}</p></div>";
			}
		}
		update_post_meta($post_id, GOSH_MESSAGES_VAR, array());
	}
};
?>