<?php
defined('ABSPATH') or die('Plugin file cannot be accessed directly.');
?>
<!-- Use nonce for verification -->
<div id="gosh-widget-settings-wrapper" style="display:none;"> <!-- Hide initialy -->
    <form id="gosh-options-form">

        <div class="form-group col-lg-3 col-md-4 col-sm-6">
            <label for="gosh_type"><i class="fa fa-th" aria-hidden="true"></i> Type</label><br/>
            <select id="gosh_type" name="gosh_type" class="form-control input-sm gosh-settings-input-field">
                <option value='live'>Live</option>
                <option value='curated'>Curated</option>
            </select>
            <div class="gosh-settings-description">Select gallery type</div>
        </div>

        <div id="gosh_key_word_box" class="form-group col-lg-3 col-md-4 col-sm-6">
            <label for="gosh_key_word"><i class="fa fa-hash" aria-hidden="true"></i> Key word</label><br/>
            <div class="btn-group" data-toggle="buttons">
              <input id='gosh_key_word' name='gosh_key_word' class='gosh-settings-input-field' type='text' value='' placeholder='#gosh_live' data-dependent="type=live">
            </div>
            <div class="gosh-settings-description">#hashtag or @username</div>
        </div>

        <div id="gosh_short_id_box" class="form-group col-lg-3 col-md-4 col-sm-6">
            <label for="gosh_short_id"><i class="fa fa-id-card-o" aria-hidden="true"></i> Gallery ID</label><br/>
            <div class="btn-group" data-toggle="buttons">
              <input id='gosh_short_id' name='gosh_short_id' class='gosh-settings-input-field' type='text' value='' placeholder='xyz123abc0' data-dependent="type=curated">
            </div>
            <div class="gosh-settings-description">Curated gallery ID</div>
        </div>

        <div id="gosh_advancedSettings_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_advancedSettings"><i class="fa fa-wrench" aria-hidden="true"></i> Advanced options</label><br/>
            <div class="btn-group" data-toggle="buttons">
              <select id='gosh_advancedSettings' name='gosh_advancedSettings' class='form-control input-sm gosh-settings-input-field ' data-dependent="type=live">
                <option value='true'>Yes</option>
                <option value='false' selected>No</option>
            </select>
            </div>
            <div class="gosh-settings-description">Show advanced set of options</div>
        </div>


        <div class="clearfix"></div>
        <hr/>

        <!-- Safe to copy to other projects -->

        <div id="gosh_layout_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_layout"><i class="fa fa-th" aria-hidden="true"></i> Layout</label><br/>
            <select id='gosh_layout' name='gosh_layout' class='form-control input-sm gosh-settings-input-field' data-dependent="type=live">
                <option value='slider'>Slider</option>
                <option value='grid'>Grid</option>
            </select>
            <div class="gosh-settings-description">Select gallery layout</div>
        </div>


        <div id="gosh_cols_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_cols"><i class="fa fa-columns" aria-hidden="true"></i> Columns</label><br/>
                <select id='gosh_cols' name='gosh_cols' class='form-control input-sm gosh-settings-input-field' data-dependent="advancedSettings=true&type=live">
                    <option value='responsive'>Responsive</option>
                    <option value='1'>1</option>
                    <option value='2'>2</option>
                    <option value='3'>3</option>
                    <option value='4'>4</option>
                    <option value='5'>5</option>
                    <option value='6'>6</option>
                    <option value='7'>7</option>
                    <option value='8'>8</option>
                    <option value='9'>9</option>
                    <option value='10'>10</option>
                </select>
            <div class="gosh-settings-description">Number of items in a row</div>
        </div>

        <div id="gosh_rows_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_rows"><i class="fa fa-table" aria-hidden="true"></i>  Rows</label><br/>
                <select id='gosh_rows' name='gosh_rows' class='form-control input-sm gosh-settings-input-field' data-dependent="layout=grid&advancedSettings=true&type=live">
                    <option value='responsive'>Responsive</option>
                    <option value='false'>No limit</option>
                    <option value='1'>1</option>
                    <option value='2'>2</option>
                    <option value='3'>3</option>
                    <option value='4'>4</option>
                    <option value='5'>5</option>
                    <option value='6'>6</option>
                    <option value='7'>7</option>
                    <option value='8'>8</option>
                    <option value='9'>9</option>
                    <option value='10'>10</option>
                </select>
            <div class="gosh-settings-description">Number of rows in a grid</div>
        </div>

        <div id="gosh_sliderControls_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_sliderControls"><i class="fa fa-arrows-h" aria-hidden="true"></i> Controls</label><br/>
                <select id='gosh_sliderControls' name='gosh_sliderControls' class='form-control input-sm gosh-settings-input-field' data-dependent="layout=slider&advancedSettings=true&type=live">
                    <option value='true'>Yes</option>
                    <option value='false'>No</option>
                    <option value='onHover'>On Hover</option>
                </select>
            <div class="gosh-settings-description">Show slider controls</div>
        </div>

        <div id="clearfix1_box"><div id="clearfix1" class='clearfix gosh-settings-input-field' data-dependent='advancedSettings=true'></div></div>

        <div id="gosh_preloadImages_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_preloadImages"><i class="fa fa-spinner" aria-hidden="true"></i> Preload images</label><br/>
                <select id='gosh_preloadImages' name='gosh_preloadImages' class='form-control input-sm gosh-settings-input-field' data-dependent="advancedSettings=true&type=live">
                    <option value='true'>Yes</option>
                    <option value='false'>No</option>
                </select>
            <div class="gosh-settings-description">Enables smoother preview</div>
        </div>

        <div id="gosh_sliderLoop_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_sliderLoop"><i class="fa fa-refresh" aria-hidden="true"></i> Loop</label><br/>
                <select id='gosh_sliderLoop' name='gosh_sliderLoop' class='form-control input-sm gosh-settings-input-field' data-dependent="layout=slider&advancedSettings=true&type=live">
                    <option value='true'>Yes</option>
                    <option value='false'>No</option>
                </select>
            <div class="gosh-settings-description">Simulate endless gallery</div>
        </div>

        <div id="gosh_autoplay_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_autoplay"><i class="fa fa-play" aria-hidden="true"></i> Animate</label><br/>
                <select id='gosh_autoplay' name='gosh_autoplay' class='form-control input-sm gosh-settings-input-field' data-dependent="layout=slider||grid&advancedSettings=true&type=live">
                    <option value='false'>No</option>
                    <option value='true'>Yes</option>
                </select>
            <div class="gosh-settings-description">Auto-play / animation</div>
        </div>

        <div id="gosh_transitionSpeed_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_transitionSpeed"><i class="fa fa-tachometer" aria-hidden="true"></i> Transition speed</label><br/>
                <select id='gosh_transitionSpeed' name='gosh_transitionSpeed' class='form-control input-sm gosh-settings-input-field' data-dependent="layout=slider||grid&advancedSettings=true&type=live">
                    <option value='fast'>Fast</option>
                    <option value='medium'>Medium</option>
                    <option value='slow'>Slow</option>
                </select>
            <div class="gosh-settings-description">Speed of transition effects</div>
        </div>

        <div id="gosh_scrollbar_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_scrollbar"><i class="fa fa-arrows-v" aria-hidden="true"></i> Scrollbar</label><br/>
                <select id='gosh_scrollbar' name='gosh_scrollbar' class='form-control input-sm gosh-settings-input-field' data-dependent="layout=grid&autoplay=false&rows!=false&advancedSettings=true&type=live">
                    <option value='true'>Yes</option>
                    <option value='false'>No</option>
                </select>
            <div class="gosh-settings-description">Show native scroll bar</div>
        </div>

        <div id="gosh_transitionDelay_box" class="form-group col-lg-2 col-md-3 col-sm-6">
             <label for="gosh_transitionDelay"><i class="fa fa-clock-o" aria-hidden="true"></i> Interval</label><br/>
                <select id='gosh_transitionDelay' name='gosh_transitionDelay' class='form-control input-sm gosh-settings-input-field' data-dependent="layout=slider||grid&advancedSettings=true&autoplay=true&type=live">
                    <option value='1500'>Small</option>
                    <option value='5000'>Medium</option>
                    <option value='10000'>Big</option>
                </select>
            <div class="gosh-settings-description">Delay between moving slides</div>
        </div>

        <div id="gosh_clearfix2_box"><div id="clearfix2" class='clearfix gosh-settings-input-field' data-dependent='advancedSettings=true&type=live'></div></div>

        <div id="gosh_theme_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_theme"><i class="fa fa-adjust" aria-hidden="true"></i> Theme</label><br/>
                <select id='gosh_theme' name='gosh_theme' class='form-control input-sm gosh-settings-input-field' data-dependent="type=live">
                    <option value='dark'>Dark</option>
                    <option value='light'>Light</option>
                </select>
            <div class="gosh-settings-description">Select color theme</div>
        </div>

        <div id="gosh_itemInfo_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_itemInfo"><i class="fa fa-info" aria-hidden="true"></i> Item info</label><br/>
                <select id='gosh_itemInfo' name='gosh_itemInfo' class='form-control input-sm gosh-settings-input-field' data-dependent="advancedSettings=true&type=live">
                    <option value='true'>Yes</option>
                    <option value='false'>No</option>
                    <option value='onHover'>On Hover</option>
                </select>
            <div class="gosh-settings-description">Display author, description...</div>
        </div>

        <div id="gosh_itemBordered_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_itemBordered"><i class="fa fa-th-large" aria-hidden="true"></i> Border</label><br/>
                <select id='gosh_itemBordered' name='gosh_itemBordered' class='form-control input-sm gosh-settings-input-field' data-dependent="advancedSettings=true&type=live">
                    <option value='true'>Yes</option>
                    <option value='false'>No</option>
                </select>
            <div class="gosh-settings-description">Add border around items</div>
        </div>

        <div id="gosh_itemAspectRatio_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_itemAspectRatio"><i class="fa fa-picture-o" aria-hidden="true"></i> Image aspect ratio</label><br/>
                <select id='gosh_itemAspectRatio' name='gosh_itemAspectRatio' class='form-control input-sm gosh-settings-input-field' data-dependent="advancedSettings=true&type=live">
                    <option value='4-3'>4:3</option>
                    <option value='16-9'>16:9</option>
                    <option value='1-1'>1:1</option>
                </select>
            <div class="gosh-settings-description">Width and height</div>
        </div>

        <div id="clearfix3_box"><div id="clearfix3" class='clearfix gosh-settings-input-field' data-dependent='advancedSettings=true&type=live'></div></div>

        <div id="gosh_lightbox_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_lightbox"><i class="fa fa-expand" aria-hidden="true"></i> Lightbox</label><br/>
                <select id='gosh_lightbox' name='gosh_lightbox' class='form-control input-sm gosh-settings-input-field' data-dependent="advancedSettings=true&type=live">
                    <option value='true'>Yes</option>
                    <option value='false'>No</option>
                </select>
            <div class="gosh-settings-description">Fullscreen item preview</div>
        </div>

        <div id="gosh_lightboxLoop_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_lightboxLoop"><i class="fa fa-refresh" aria-hidden="true"></i>  Loop</label><br/>
                <select id='gosh_lightboxLoop' name='gosh_lightboxLoop' class='form-control input-sm gosh-settings-input-field' data-dependent="layout=grid&lightbox=true&advancedSettings=true&type=live">
                    <option value='true'>Yes</option>
                    <option value='false'>No</option>
                </select>
            <div class="gosh-settings-description">Simulate endless gallery</div>
        </div>

        <div id="gosh_lightboxSocialShare_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_lightboxSocialShare"><i class="fa fa-share-alt" aria-hidden="true"></i> Social Sharing</label><br/>
                <select id='gosh_lightboxSocialShare' name='gosh_lightboxSocialShare' class='form-control input-sm gosh-settings-input-field' data-dependent="lightbox=true&advancedSettings=true&type=live">
                    <option value='true'>Yes</option>
                    <option value='false'>No</option>
                </select>
            <div class="gosh-settings-description">Enable icons for social sharing</div>
        </div>

        <div id="gosh_lightboxVideoAutoplay_box" class="form-group col-lg-2 col-md-3 col-sm-6">
            <label for="gosh_lightboxVideoAutoplay"><i class="fa fa-play" aria-hidden="true"></i> Video autoplay</label><br/>
                <select id='gosh_lightboxVideoAutoplay' name='gosh_lightboxVideoAutoplay' class='form-control input-sm gosh-settings-input-field' data-dependent="lightbox=true&advancedSettings=true&type=live">
                    <option value='false'>No</option>
                    <option value='true'>Yes</option>
                </select>
            <div class="gosh-settings-description">Autostart videos on preview</div>
        </div>

        <!-- /end safe to copy to other projects -->

        <div class="clearfix"></div><hr/>

        <div class="gosh-shortcode-box">
            <div class='gosh-settings-title'>Shortcode:</div>
            <div class="gosh-shortcode">[<?php echo GOSH_SHORTCODE." key_word='<span id=\"shortcode-keyword\"></span>' id='".$data['post_id']?>'/]</div>
            <div class="gosh-settings-description">Paste generated snippet where you want your gallery to appear.</div>
        </div>

        <input id="gosh_nonce" name="gosh_nonce" type="hidden" value="<?php echo wp_create_nonce('gosh_nonce')?>" />
    </form>
</div>
<div class="clearfix"></div>
<hr/>

<div id="gosh-widget-editor" data-user-id="wordpress_<?php echo GOSH_USER_ID?>" data-project-id="<?php echo GOSH_SITE_ID."|-|".$data['post_id']?>"><p class="text-center"><img src="<?php echo GOSH_PLUGIN_URL."/".GOSH_PLUGIN_DIR?>/img/ajax-loader.gif" /></p></div> <!-- gallery continer -->
<script src="<?php echo GOSH_VIEWER_ASSETS?>javascripts/gsw.3.1.js"></script>
<script>
(function($){
    var goshEventObj = {createItem: function(container, data){
       // Delete button
       var delBtn = document.createElement('div');
       delBtn.className = 'gsw-delete-btn';
       delBtn.innerHTML = 'delete';
       delBtn.setAttribute('data-id', data.id);
       // Add Event on delete btn click
       $(delBtn).on('click', function(e){
           e.stopPropagation();
           if(window.__goshwgt.rawSettings.autoplay == true) {window.__goshwgt.ctrl.pause();}
           GOSH_WGT.confirmationDialog(delBtn.parentNode, function(result){
               // Apply
               if(result){
                  // Remove item from database
                  GOSH_WGT.remove(data.id);
                  var media = window.__goshwgt.getData();
                  // ... and from dom
                  for(var i = 0; i < media.length; i ++){
                      // Find item targeted for deletion
                      if(media[i].id == data.id) {
                          media.splice(i, 1);
                          window.__goshwgt.setData(media);
                          if(window.__goshwgt.rawSettings.layout == 'grid'){
                              // Static grid
                              if(window.__goshwgt.rawSettings.autoplay === false){
                                  // Move all other items following the deleted one for one place to the left
                                  for(var j = window.__goshwgt.getOption().wrapper.element.childNodes.length - 1; j > i; j--){
                                      window.__goshwgt.getOption().wrapper.element.childNodes[j].style.left = window.__goshwgt.getOption().wrapper.element.childNodes[j-1].style.left;
                                      window.__goshwgt.getOption().wrapper.element.childNodes[j].style.top  = window.__goshwgt.getOption().wrapper.element.childNodes[j-1].style.top;
                                      // First row item
                                      if(parseInt(window.__goshwgt.getOption().wrapper.element.childNodes[j].style.top) === 0){
                                          var target = window.__goshwgt.getOption().wrapper.element.childNodes[j];
                                          target.style.borderTop = target.style.borderBottom;
                                      }
                                  }
                                  // Remove from the dom
                                  window.__goshwgt.getOption().wrapper.element.childNodes[i].parentNode.removeChild(window.__goshwgt.getOption().wrapper.element.childNodes[i]);
                              }else{
                                  // Animated grid
                                  window.__goshwgt.reInit();
                              }
                          } else {
                              // Slider
                              window.__goshwgt.reInit();
                          }
                      }
                  }
               // Canceled
               }else{
                   if(window.__goshwgt.getOption().autoplay === 'paused') {
                       window.__goshwgt.ctrl.play();
                   }
               }
           });
       });
       container.appendChild(delBtn);
   },
   init:       function(){},
   built:      function(){},
   slider:     function(result){},
   lightbox:   function(result){}
  };

    GOSH_WGT.info(function(gallery) {
        console.log('Gallery info:', gallery);
        var options = gallery.settings;
        if (typeof options !== 'undefined' && options.type === 'curated') {
            // Get hash_url
            $.post('<?php echo GOSH_API_URL?>', {
                action: 'exchange_project_short_id',
                short_id: options.short_id
            }, function (result) {
                var curated_hash_url = result.hash_url;
                GoshSaveSettingsAjax(GOSH_CFG.get('user_token'), curated_hash_url);
                if (result.success) {
                    // Check if gallery exist
                    $.ajax({
                        url: GOSH_CFG.get('apiViewerRoot') + 'jsons/' + curated_hash_url + '/status.json',
                        type: 'HEAD',
                        error: function () {
                            $.get(GOSH_CFG.get('apiViewerRoot') + 'datas/galleries/__default__.json', function (data) {
                                var settings = {report: false};
                                GSW('gosh-widget-editor', data, settings);
                            });
                        },
                        success: function () {
                            // get Data
                            $.get(GOSH_CFG.get('apiViewerRoot') + 'jsons/' + curated_hash_url + '/pages/000000.json.gz', function (data) {
                                // get Settings
                                $.get(GOSH_CFG.get('apiViewerRoot') + 'jsons/' + curated_hash_url + '/settings.json', function (settings) {
                                    $('#shortcode-keyword').text(settings.keyWord);
                                    // get Campaign
                                    $.ajax({
                                        url: GOSH_CFG.get('apiViewerRoot') + 'jsons/' + curated_hash_url + '/campaign.json',
                                        dataType: "json",
                                        success: function (campaign) {
                                            settings.campaign = campaign;
                                        },
                                        error: function () {
                                            settings.campaign = {};
                                        },
                                        complete: function (xhr) {
                                            GSW('gosh-widget-editor', data, settings);
                                        }
                                    })
                                });
                            });
                        }
                    });
                } else {
                    $.ajax({
                        url: 'https://www.gosh.live/embed/empty_curated.php',
                        success: function (data) {
                            var settings = {report: false};
                            GSW('gosh-widget-editor', data, settings);
                        }, error: function (err) {
                            console.log('Error', JSON.parse(err.responseText));
                        }
                    });
                }
            });
        } else {
            GoshSaveSettingsAjax(GOSH_CFG.get('user_token'), gallery.hash_url);
            $('#shortcode-keyword').text(gallery.key_word);
            // Create New gallery
            if (typeof gallery.hash_url === 'undefined') {
                console.log('Creating new gallery');
                GOSH_WGT.create(function (result) {
                    var options = {usageType : 'edit'};
                    GOSH_WGT.getData('__placeholder__', function (data, type, state) {
                        window.__goshwgt = GOSH_WGT.load('gosh-widget-editor', data, 'special', options);
                        GOSH_WGT.setOptionFields(gallery.key_word, {});
                    });
                });
            } else {
                // Existing gallery
                $('#gosh_hash_url').val(gallery.hash_url);
                $('#gosh_project_id').val(gallery.project_id);
                GOSH_WGT.getData(gallery.hash_url, function (data, type, state) {
                    if (state == 'waiting') {
                        window.__goshwgt = GOSH_WGT.load('gosh-widget-editor', data, type, options);
                        (function reCheckState() {
                            setTimeout(function () {
                                GOSH_WGT.getData(gallery.hash_url, function (data, type, state) {
                                    // Empty gallery
                                    if (data.length == 0) {
                                        GOSH_WGT.getData('__empty__', function (data, type) {
                                            window.__goshwgt.setData(data);
                                            window.__goshwgt.reInit();
                                            GOSH_WGT.setOptionFields(gallery.key_word, {});
                                        });
                                    } else {
                                        if (data[0].id.indexOf('gosh') != -1) reCheckState(); // Still in the making...so recheck every xxx sec
                                        else {
                                            options.onEvent = goshEventObj;
                                            window.__goshwgt.setData(data);
                                            window.__goshwgt.reInit();
                                            GOSH_WGT.setOptionFields('', {});

                                        }
                                    }
                                });
                            }, 5000);
                        })();
                    } else {
                        // Empty gallery
                        if (data.length == 0) {
                            GOSH_WGT.getData('__empty__', function (data, type) {
                                window.__goshwgt = GOSH_WGT.load('gosh-widget-editor', data, 'special', options);
                                GOSH_WGT.setOptionFields(gallery.options);
                            });
                        } else {
                            // Add additional functionality
                            GOSH_WGT.setOptionFields(gallery.key_word, options);
                            options.onEvent = goshEventObj;
                            options.usageType = 'edit';
                            window.__goshwgt = GOSH_WGT.load('gosh-widget-editor', data, type, options);
                        }
                    }
                });
            }
        }

        // Attach events
        $('#publish').on('mousedown', function (e) {
            e.preventDefault();
            //var options = JSON.stringify(GOSH_WGT.getOptions());
            // Check for param update
            console.log()
            GOSH_WGT.update(function (result, options) {
                console.log('Widget updated:', result.settings.type);
            });
        });

        $('.gosh-settings-input-field').on('change', function () {
            gosh_util.configurationFieldControl.check();
            if (typeof window.__goshwgt !== 'undefined') {
                window.__goshwgt.setOption(GOSH_WGT.getOptions());
                window.__goshwgt.reInit();
            }
        });
        GOSH_WGT.setOptionFields(gallery.key_word, gallery.settings);
        gosh_util.configurationFieldControl.check();
    });
})(jQuery);
</script>